/*
 * WorldGuard, a suite of tools for Minecraft
 * Copyright (C) sk89q <http://www.sk89q.com>
 * Copyright (C) WorldGuard team and contributors
 *
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

package com.sk89q.worldguard.session;

import com.sk89q.worldedit.world.World;
import com.sk89q.worldguard.LocalPlayer;

public class WorldPlayerTuple {

    private final World world;
    private final LocalPlayer player;

    public WorldPlayerTuple(World world, LocalPlayer player) {
        this.world = world;
        this.player = player;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        WorldPlayerTuple that = (WorldPlayerTuple) o;

        if (!player.equals(that.player)) return false;
        if (!world.equals(that.world)) return false;

        return true;
    }

    public LocalPlayer getPlayer() {
        return player;
    }

    public World getWorld() {
        return world;
    }

    @Override
    public int hashCode() {
        int result = world.hashCode();
        result = 31 * result + player.hashCode();
        return result;
    }

}
